// OptionDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "OptionDlg.h"
#include "afxdialogex.h"


// COptionDlg _CAO

IMPLEMENT_DYNAMIC(COptionDlg, CDialog)

COptionDlg::COptionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionDlg::IDD, pParent)
	, select_(0)
{

}

COptionDlg::~COptionDlg()
{
	if (font_.GetSafeHandle()) { font_.DeleteObject(); }
}

void COptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TREE, m_xcTree);
}

void COptionDlg::setTitle(const std::wstring& title)
{
	std::wstring text = L"IvV - " + title;
	SetWindowText(text.c_str());

	CWnd *wnd = GetDlgItem(IDC_STATIC);
	if (wnd)
	{
		wnd->SetWindowText(title.c_str());
	}
}



BEGIN_MESSAGE_MAP(COptionDlg, CDialog)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE, &COptionDlg::OnTvnSelchangedTree)
END_MESSAGE_MAP()


// COptionDlg bZ[W nh[


BOOL COptionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	auto parent = [this](const std::wstring& text)->HTREEITEM {
		HTREEITEM item = m_xcTree.InsertItem(text.c_str());
		m_xcTree.SetItemState(item, TVIS_BOLD|TVIS_EXPANDED, TVIS_BOLD|TVIS_EXPANDED);
		return item;
	};

	auto bind = [this](HTREEITEM parent, const std::wstring& text, CDialog* dlg, int idd)->bool {
		if (dlg == NULL) { return false; }
		auto item = m_xcTree.InsertItem(text.c_str(), parent);

		Item tmp = { item, text, dlg, idd };
		vec_.push_back(tmp);
		return true;
	};

	//----------------------------------------------------------

	HTREEITEM item = NULL;

	item = parent(L"fݒ");
	bind(item, L"f",				&video_.adjust, CVideoAdjustDlg::IDD);

	item = parent(L"ڍאݒ");
	bind(item, L"lbg[N",			&detail_.network, CDetailNetworkDlg::IDD);
	bind(item, L"^Cv",				&detail_.type, CDetailTypeDlg::IDD);
	bind(item, L"fR[_",				&detail_.decoder, CDetailDecoderDlg::IDD);
	bind(item, L"uEU",				&detail_.browser, CDetailBrowserDlg::IDD);
	bind(item, L"XibvVbg",		&detail_.snapshot, CDetailSnapshotDlg::IDD);
	bind(item, L"BBSo[",				&detail_.board, CDetailBoardDlg::IDD);
	bind(item, L"N",				&detail_.start, CDetailStartDlg::IDD);
	bind(item, L"I",				&detail_.end, CDetailEndDlg::IDD);
	
	item = parent(L"ݒ");
	bind(item, L"V[gJbg",		&operation_.shortcut, COperationShortcutDlg::IDD);
	bind(item, L"}EX",				&operation_.mouse, COperationMouseDlg::IDD);
	bind(item, L"zC[ω",		&operation_.variation, COperationVariationDlg::IDD);
	bind(item, L"EBhE",			&operation_.window, COperationWindowDlg::IDD);

	item = parent(L"\ݒ");
	bind(item, L"{/TCY",			&display_.window, CDisplayWindowDlg::IDD);
	bind(item, L"AXyNg",			&display_.aspect, CDisplayAspectDlg::IDD);
	bind(item, L"",					&display_.datetime, CDisplayDatetimeDlg::IDD);
	bind(item, L"`l",		&display_.information, CDisplayInformationDlg::IDD);

	item = parent(L"CAEg");
	bind(item, L"Xe[^Xo[",		&display_.status, CDisplayStatusDlg::IDD);
	bind(item, L"V[No[",			&display_.seek, CDisplaySeekDlg::IDD);
	bind(item, L"V[Nqg",			&display_.hint, CDisplayHintDlg::IDD);
	bind(item, L"`l",		&display_.channel, CDisplayChannelDlg::IDD);
	bind(item, L"BBSo[",				&display_.bbs, CDisplayBBSDlg::IDD);
	bind(item, L"X|bvAbv",		&display_.res, CDisplayResDlg::IDD);

	//----------------------------------------------------------

	int marginX = 16, marginY = 8;

	CRect rc;
	m_xcTree.GetWindowRect(&rc);
	int x = rc.Width();

	int y = 0;
	CWnd *wnd = GetDlgItem(IDC_STATIC);
	if (wnd)
	{
		wnd->GetWindowRect(&rc);
		y = rc.Height();
	}

	pos_.SetPoint(x + marginX, y + marginY);

	try {
		Item i = vec_.at(select_);
		i.dlg->Create(i.idd, this);
		i.dlg->SetWindowPos(NULL, pos_.x, pos_.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		i.dlg->ShowWindow(SW_SHOW);
		m_xcTree.SetItemState(i.item, TVIS_SELECTED, TVIS_SELECTED);
		setTitle(i.title);
	}
	catch (...) {}


	wnd = GetDlgItem(IDC_STATIC);
	if (wnd)
	{
		LOGFONT lf;
		GetFont()->GetLogFont(&lf);
		lf.lfWeight = FW_BOLD;
		font_.CreateFontIndirect(&lf);

		wnd->SetFont(&font_);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL COptionDlg::PreTranslateMessage(MSG* pMsg)
{
	return CDialog::PreTranslateMessage(pMsg);
}


void COptionDlg::OnTvnSelchangedTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	HTREEITEM item = pNMTreeView->itemNew.hItem;

	HTREEITEM parent = m_xcTree.GetParentItem(item);

	if (parent != NULL)
	{
		int i = 0;
		for (auto it = vec_.begin(); it != vec_.end(); ++it)
		{
			if (it->dlg)
			{
				if (it->item == item)
				{
					if (!::IsWindow(it->dlg->GetSafeHwnd()))
					{
						it->dlg->Create(it->idd, this);
						it->dlg->SetWindowPos(NULL, pos_.x, pos_.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
					}
					it->dlg->ShowWindow(SW_SHOW);
					setTitle(it->title);
					select_ = i;
				}
				else
				{
					if (::IsWindow(it->dlg->GetSafeHwnd()))
					{
						it->dlg->ShowWindow(SW_HIDE);
					}
				}
			}
			++i;
		}
	}

	if (pResult) { *pResult = 0; }
}

